//----------------------------------------------------------------------------------------------
//Board Library : esp32 by Espressif 3.0.4
//Board Select  : XIAO_ESP32C6
//----------------------------------------------------------------------------------------------
// blink by register manipulation
// 2024/09/21 @msfujino

void setup() {
  Serial.begin(115200);
//  while(!Serial);
  delay(5000);
  Serial.println("Blink TEST");

  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH);  
}

void loop() {
  *((uint32_t*)0x60091004) &= 0xFFFF7FFF;   // GPIO_15=LOW
  // 7.15.1 GPIO Matrix Register Summary
  // 5.3.5 Modules/Peripherals Address Mapping
  // Base Address IO MUX:0x6009_0000, GPIO Matrix:0x6009_1000
  Serial.print("GPIO_PIN15_REG\t\t"); Serial.println(*((uint32_t*)0x600910B0), HEX);    // 0x74+3C=0xB0
  Serial.print("IO_MUX_GPIO15_REG\t"); Serial.println(*((uint32_t*)0x60090040), HEX);   // 0x04+3C=0x40
  Serial.print("GPIO_ENABLE_REG\t\t"); Serial.println(*((uint32_t*)0x60091020), HEX);   // enable GPIO_3, _14, _15
  Serial.print("GPIO_OUT_REG\t\t"); Serial.println(*((uint32_t*)0x60091004), HEX);

  delay(100);
  *((uint32_t*)0x60091004) |= 0x00008000;   // GPIO_15=HIGH

  Serial.print("GPIO_OUT_REG\t\t"); Serial.println(*((uint32_t*)0x60091004), HEX);
  Serial.println();
  delay(1000);
}
